org.apache.struts2.result

## Class ServletActionRedirectResult

- java.lang.Object
- - org.apache.struts2.result.StrutsResultSupport
  - - org.apache.struts2.result.ServletRedirectResult
    - - org.apache.struts2.result.ServletActionRedirectResult

- All Implemented Interfaces:
    ReflectionExceptionHandler, Serializable, Redirectable, Result, StrutsStatics

      public class ServletActionRedirectResult
      extends ServletRedirectResult
      implements ReflectionExceptionHandler, Redirectable

  This result uses the `ActionMapper` provided by the ActionMapperFactory to redirect the browser to a URL that invokes the specified action and (optional) namespace. This is better than the `ServletRedirectResult` because it does not require you to encode the URL patterns processed by the `ActionMapper` in to your struts.xml configuration files. This means you can change your URL patterns at any point and your application will still work. It is strongly recommended that if you are redirecting to another action, you use this result rather than the standard redirect result.

  See examples below for an example of how request parameters could be passed in.

  This result type takes the following parameters:

  - actionName (default) - The name of the action that will be redirected to.
  - namespace - Used to determine which namespace the action is in that we're redirecting to. If namespace is null, the default will be the current namespace.
  - suppressEmptyParameters - Optional boolean (defaults to false) that can prevent parameters with no values from being included in the redirect URL.
  - parse - Boolean, true by default. If set to false, the actionName param will not be parsed for Ognl expressions.
  - anchor - Optional. Also known as "fragment" or colloquially as "hash". You can specify an anchor for a result.

  Example:

       <package name="public" extends="struts-default">
           <action name="login" class="...">
               <!-- Redirect to another namespace -->
               <result type="redirectAction">
                   <param name="actionName">dashboard</param>
                   <param name="namespace">/secure</param>
               </result>
           </action>
       </package>

       <package name="secure" extends="struts-default" namespace="/secure">
           <-- Redirect to an action in the same namespace -->
           <action name="dashboard" class="...">
               <result>dashboard.jsp</result>
               <result name="error" type="redirectAction">error</result>
           </action>

           <action name="error" class="...">
               <result>error.jsp</result>
           </action>
       </package>

       <package name="passingRequestParameters" extends="struts-default" namespace="/passingRequestParameters">
          <!-- Pass parameters (reportType, width and height) -->
          <!--
          The redirectAction url generated will be :
          /genReport/generateReport.action?reportType=pie&width=100&height=100#summary
          -->
          <action name="gatherReportInfo" class="...">
             <result name="showReportResult" type="redirectAction">
                <param name="actionName">generateReport</param>
                <param name="namespace">/genReport</param>
                <param name="reportType">pie</param>
                <param name="width">100</param>
                <param name="height">100</param>
                <param name="empty"></param>
                <param name="suppressEmptyParameters">true</param>
                <param name="anchor">summary</param>
             </result>
          </action>
       </package>

  See Also:
    `ActionMapper`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.opensymphony.xwork2.Result

      `Result.LegacyAdapter`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `actionName`
    `static String` | `DEFAULT_PARAM`
    `protected String` | `method`
    `protected String` | `namespace`

    - ### Fields inherited from class org.apache.struts2.result.ServletRedirectResult

      `actionMapper, anchor, prependServletContext, requestParameters, statusCode, suppressEmptyParameters`

    - ### Fields inherited from class org.apache.struts2.result.StrutsResultSupport

      `DEFAULT_URL_ENCODING, parseLocation`

    - ### Fields inherited from interface org.apache.struts2.StrutsStatics

      `ACTION_MAPPING, HTTP_REQUEST, HTTP_RESPONSE, PAGE_CONTEXT, SERVLET_CONTEXT, SERVLET_DISPATCHER, STRUTS_ACTION_TAG_INVOCATION, STRUTS_PORTLET_CONTEXT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServletActionRedirectResult()`
    `ServletActionRedirectResult(String actionName)`
    `ServletActionRedirectResult(String actionName, String method)`
    `ServletActionRedirectResult(String namespace, String actionName, String method)`
    `ServletActionRedirectResult(String namespace, String actionName, String method, String anchor)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `execute(ActionInvocation invocation)` Implementation of the `execute` method from the `Result` interface.
    `protected List<String>` | `getProhibitedResultParams()`
    `void` | `setActionName(String actionName)` Sets the action name
    `void` | `setMethod(String method)` Sets the method
    `void` | `setNamespace(String namespace)` Sets the namespace

    - ### Methods inherited from class org.apache.struts2.result.ServletRedirectResult

      `addParameter, doExecute, handle, isPathUrl, sendRedirect, setActionMapper, setAnchor, setPrependServletContext, setQueryStringBuilder, setStatusCode, setSuppressEmptyParameters`

    - ### Methods inherited from class org.apache.struts2.result.StrutsResultSupport

      `conditionalParse, conditionalParseCollection, doExecute, getLastFinalLocation, getLocation, setEncode, setLocation, setParse`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.opensymphony.xwork2.util.reflection.ReflectionExceptionHandler

      `handle`

    - ### Methods inherited from interface com.opensymphony.xwork2.Result

      `adapt, execute`

- - ### Field Detail

    - #### DEFAULT_PARAM

          public static final String DEFAULT_PARAM

      See Also:
        Constant Field Values

    - #### actionName

          protected String actionName

    - #### namespace

          protected String namespace

    - #### method

          protected String method

  - ### Constructor Detail

    - #### ServletActionRedirectResult

          public ServletActionRedirectResult()

    - #### ServletActionRedirectResult

          public ServletActionRedirectResult(String actionName)

    - #### ServletActionRedirectResult

          public ServletActionRedirectResult(String actionName,
                                             String method)

    - #### ServletActionRedirectResult

          public ServletActionRedirectResult(String namespace,
                                             String actionName,
                                             String method)

    - #### ServletActionRedirectResult

          public ServletActionRedirectResult(String namespace,
                                             String actionName,
                                             String method,
                                             String anchor)

  - ### Method Detail

    - #### execute

          public void execute(ActionInvocation invocation)
                       throws Exception

      Description copied from class: `StrutsResultSupport`
      Implementation of the `execute` method from the `Result` interface. This will call the abstract method `StrutsResultSupport.doExecute(String, ActionInvocation)` after optionally evaluating the location as an OGNL evaluation.
      Overrides:
        `execute` in class `ServletRedirectResult`
      Parameters:
        `invocation` - the execution state of the action.
      Throws:
        `Exception` - if an error occurs while executing the result.
      See Also:
        `Result.execute(com.opensymphony.xwork2.ActionInvocation)`

    - #### setActionName

          public void setActionName(String actionName)

      Sets the action name
      Parameters:
        `actionName` - The name

    - #### setNamespace

          public void setNamespace(String namespace)

      Sets the namespace
      Parameters:
        `namespace` - The namespace

    - #### setMethod

          public void setMethod(String method)

      Sets the method
      Parameters:
        `method` - The method

    - #### getProhibitedResultParams

          protected List<String> getProhibitedResultParams()

      Overrides:
        `getProhibitedResultParams` in class `ServletRedirectResult`

Copyright © 2000–2026 Apache Software Foundation. All rights reserved.